Compare commits

..

10 Commits

Author SHA1 Message Date
mudler 4b2cf1141c [sabayon-buildpackages] add support for ETP_NOCACHE 2016-08-04 11:25:21 +02:00
Ettore Di Giacinto 6e3ae4db29 builder: cleanup 2016-07-23 18:33:13 +02:00
Ettore Di Giacinto d3e174eb10 sabayon-buildpackages: add support for REMOTE_PORTDIR and REMOTE_CONF_PORTDIR 2016-07-23 18:30:43 +02:00
Ettore Di Giacinto 4c4279e707 builder: add support for remote portdir and portage configurations 2016-07-23 18:30:03 +02:00
mudler 0e33e0d75f builder: enable more verbosity to debug QA_CHECKS 2016-07-21 10:23:16 +02:00
mudler cd19f3b85b [builder] add equo args (multifetch && co.) 2016-07-21 10:20:06 +02:00
Ettore Di Giacinto b899a21852 [sabayon-buildpackages] support mounting of /etc/portage/env 2016-07-18 22:36:00 +02:00
Ettore Di Giacinto c9ad172bd4 [sabayon-buildpackages] mount packages.env instead populating packages.env/ 2016-07-18 22:26:33 +02:00
Ettore Di Giacinto cdac817e59 sabayondevkit-functions: trying softly to start docker daemon 2016-07-16 15:36:57 +02:00
Ettore Di Giacinto b33b4aa619 [builder] print qa checks if we are doing et 2016-07-16 10:27:54 +02:00
3 changed files with 36 additions and 9 deletions
+30 -6
View File
@@ -35,8 +35,11 @@ my $enman_add_self = $ENV{ENMAN_ADD_SELF} // 0;
my $build_injected_args = $ENV{BUILD_INJECTED_ARGS}; my $build_injected_args = $ENV{BUILD_INJECTED_ARGS};
my $equo_masks = $ENV{EQUO_MASKS}; my $equo_masks = $ENV{EQUO_MASKS};
my $equo_unmasks = $ENV{EQUO_UNMASKS}; my $equo_unmasks = $ENV{EQUO_UNMASKS};
my $equo_install_args = $ENV{EQUO_INSTALL_ARGS} // "--multifetch=10";
my $remote_overlay = $ENV{REMOTE_OVERLAY}; my $remote_overlay = $ENV{REMOTE_OVERLAY};
my $repoman_check = $ENV{QA_CHECKS} // 0; my $repoman_check = $ENV{QA_CHECKS} // 0;
my $remote_conf_portdir = $ENV{REMOTE_CONF_PORTDIR};
my $remote_portdir = $ENV{REMOTE_PORTDIR};
my $make_conf = $ENV{MAKE_CONF}; my $make_conf = $ENV{MAKE_CONF};
@@ -244,7 +247,24 @@ say "[*] Syncing configurations files, Layman and Portage";
# Syncronizing portage configuration and adding overlays # Syncronizing portage configuration and adding overlays
system("echo 'en_US.UTF-8 UTF-8' > /etc/locale.gen"); #be sure about that. system("echo 'en_US.UTF-8 UTF-8' > /etc/locale.gen"); #be sure about that.
system("cd /etc/portage/;git checkout master; git stash; git pull");
# If defined, fetch a remote /etc/portage
if ($remote_conf_portdir ne "") {
system("rm -rf /etc/portage");
system("git clone $remote_conf_portdir /etc/portage");
system("chown -R portage:portage /etc/portage");
system("chmod -R ug+w,a+rX /etc/portage");
} else {
system("cd /etc/portage/;git checkout master; git stash; git pull");
}
# If defined, fetch a remote /usr/portage
if ($remote_portdir ne "") {
system("rm -rf /usr/portage");
system("git clone $remote_portdir /usr/portage");
system("chown -R portage:portage /usr/portage");
system("chmod -R ug+w,a+rX /usr/portage");
}
system("echo 'y' | layman -f -a $_") for @overlays; system("echo 'y' | layman -f -a $_") for @overlays;
@@ -343,7 +363,6 @@ if ($use_equo) {
system("cp -rf $make_conf /etc/portage/make.conf") if $make_conf; system("cp -rf $make_conf /etc/portage/make.conf") if $make_conf;
my @packages = @ARGV; my @packages = @ARGV;
my @injected_packages = (); my @injected_packages = ();
if ($build_injected_args) { if ($build_injected_args) {
@@ -393,7 +412,7 @@ if ($use_equo) {
say "", "[install] Those dependencies will be installed with equo :", say "", "[install] Those dependencies will be installed with equo :",
@packages_deps, ""; @packages_deps, "";
if ($equo_split_install) { if ($equo_split_install) {
safe_call("equo i --bdeps $_") safe_call("equo i $equo_install_args --bdeps $_")
for ( @packages_deps, @equo_install ) for ( @packages_deps, @equo_install )
; ## bail out here, if installs fails. emerge will compile a LOT of stuff ; ## bail out here, if installs fails. emerge will compile a LOT of stuff
if ( @equo_remove > 0 ) { if ( @equo_remove > 0 ) {
@@ -401,16 +420,21 @@ if ($use_equo) {
} }
} }
else { else {
safe_call("equo i --bdeps @packages_deps @equo_install") safe_call(
"equo i $equo_install_args --bdeps @packages_deps @equo_install")
if ( @packages_deps > 0 or @equo_install > 0 ) if ( @packages_deps > 0 or @equo_install > 0 )
; ## bail out here, if installs fails. emerge will compile a LOT of stuff ; ## bail out here, if installs fails. emerge will compile a LOT of stuff
system("equo rm --nodeps @equo_remove") if ( @equo_remove > 0 ); system("equo rm --nodeps @equo_remove") if ( @equo_remove > 0 );
} }
} }
say "*** Repoman checks ***";
if ( $repoman_check == 1 ) { if ( $repoman_check == 1 ) {
say "*** QA checks for $_" && system("pushd \$(dirname \$(equery which $_ 2>/dev/null)); repoman; popd") for ( @packages, @injected_packages ); say "*** Repoman checks ***";
for ( @packages, @injected_packages ) {
say "*** QA checks for $_";
system(
"pushd \$(dirname \$(equery which $_ 2>/dev/null)); repoman; popd");
}
} }
say "*** Ready to compile, finger crossed ***"; say "*** Ready to compile, finger crossed ***";
+5 -2
View File
@@ -53,7 +53,9 @@ docker_volumes=( -v "$OUTPUT_DIR:/usr/portage/packages" )
[ -z "$REMOVE_LAYMAN_OVERLAY" ] || docker_env+=(-e "REMOVE_LAYMAN_OVERLAY=$REMOVE_LAYMAN_OVERLAY") [ -z "$REMOVE_LAYMAN_OVERLAY" ] || docker_env+=(-e "REMOVE_LAYMAN_OVERLAY=$REMOVE_LAYMAN_OVERLAY")
[ -z "$REMOVE_REMOTE_OVERLAY" ] || docker_env+=(-e "REMOVE_REMOTE_OVERLAY=$REMOVE_REMOTE_OVERLAY") [ -z "$REMOVE_REMOTE_OVERLAY" ] || docker_env+=(-e "REMOVE_REMOTE_OVERLAY=$REMOVE_REMOTE_OVERLAY")
[ -z "$QA_CHECKS" ] || docker_env+=(-e "QA_CHECKS=$QA_CHECKS") [ -z "$QA_CHECKS" ] || docker_env+=(-e "QA_CHECKS=$QA_CHECKS")
[ -z "$REMOTE_CONF_PORTDIR" ] || docker_env+=(-e "REMOTE_CONF_PORTDIR=$REMOTE_CONF_PORTDIR")
[ -z "$REMOTE_PORTDIR" ] || docker_env+=(-e "REMOTE_PORTDIR=$REMOTE_PORTDIR")
[ -z "$ETP_NOCACHE" ] || docker_env+=(-e "ETP_NOCACHE=$ETP_NOCACHE")
[ -d "$LOCAL_OVERLAY" ] && docker_volumes+=(-v "$LOCAL_OVERLAY:/usr/local/local_portage") [ -d "$LOCAL_OVERLAY" ] && docker_volumes+=(-v "$LOCAL_OVERLAY:/usr/local/local_portage")
if [ -e $MAKE_CONF ]; then if [ -e $MAKE_CONF ]; then
@@ -71,8 +73,9 @@ if [ -d "$SAB_WORKSPACE"/specs ]; then
[ -e "$SAB_WORKSPACE"/specs/custom.mask ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.mask:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.mask/99-custom.mask") [ -e "$SAB_WORKSPACE"/specs/custom.mask ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.mask:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.mask/99-custom.mask")
[ -e "$SAB_WORKSPACE"/specs/custom.unmask ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.unmask:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.unmask/99-custom.unmask") [ -e "$SAB_WORKSPACE"/specs/custom.unmask ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.unmask:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.unmask/99-custom.unmask")
[ -e "$SAB_WORKSPACE"/specs/custom.use ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.use:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.use/99-custom.use") [ -e "$SAB_WORKSPACE"/specs/custom.use ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.use:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.use/99-custom.use")
[ -e "$SAB_WORKSPACE"/specs/custom.env ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.env:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.env/99-custom.env") [ -e "$SAB_WORKSPACE"/specs/custom.env ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.env:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.env")
[ -e "$SAB_WORKSPACE"/specs/custom.keywords ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.keywords:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.keywords/99-custom.keywords") [ -e "$SAB_WORKSPACE"/specs/custom.keywords ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/custom.keywords:/opt/sabayon-build/conf/$SAB_ARCH/portage/package.keywords/99-custom.keywords")
[ -d "$SAB_WORKSPACE"/specs/env ] && docker_volumes+=(-v "$SAB_WORKSPACE/specs/env/:/opt/sabayon-build/conf/$SAB_ARCH/portage/env/")
fi fi
+1 -1
View File
@@ -4,7 +4,7 @@ check_docker_requirements(){
if [ "$(id -u)" != "0" ]; then if [ "$(id -u)" != "0" ]; then
groups | grep -q docker || echo "--> If you are not running the script as root, your user should be in the docker group to use it. (sudo gpasswd -a $USER docker)" groups | grep -q docker || echo "--> If you are not running the script as root, your user should be in the docker group to use it. (sudo gpasswd -a $USER docker)"
fi fi
ps aux | grep -q '[d]ocker' || echo "--> Be sure to have the docker daemon running (sudo systemctl start docker) of configure it to run on boot (sudo systemctl enable docker). Trying to start it anyway" && sudo systemctl start docker ps aux | grep -q '[d]ocker' || echo "--> Be sure to have the docker daemon running (sudo systemctl start docker) of configure it to run on boot (sudo systemctl enable docker). Trying to start it anyway" && sudo systemctl start docker || true
} }
die() { echo "$@" 1>&2 ; exit 1; } die() { echo "$@" 1>&2 ; exit 1; }